diff --git a/tests/fate/imf.mak b/tests/fate/imf.mak
index feb54d1361..49ab35e7d9 100644
--- a/tests/fate/imf.mak
+++ b/tests/fate/imf.mak
@@ -1,6 +1,9 @@
 FATE_IMF += fate-imf-cpl-with-repeat
 fate-imf-cpl-with-repeat: CMD = framecrc -f imf -i $(TARGET_SAMPLES)/imf/countdown/CPL_bb2ce11c-1bb6-4781-8e69-967183d02b9b.xml -c:v copy
 
+FATE_IMF += fate-imf-cpl-with-audio
+fate-imf-cpl-with-audio: CMD = framecrc -f imf -i $(TARGET_SAMPLES)/imf/countdown-audio/CPL_688f4f63-a317-4271-99bf-51444ff39c5b.xml -c:a copy
+
 FATE_SAMPLES_FFMPEG-$(CONFIG_IMF_DEMUXER) += $(FATE_IMF)
 
 fate-imfdec: $(FATE_IMF)
diff --git a/tests/ref/fate/imf-cpl-with-audio b/tests/ref/fate/imf-cpl-with-audio
new file mode 100644
index 0000000000..0a1d87631a
--- /dev/null
+++ b/tests/ref/fate/imf-cpl-with-audio
@@ -0,0 +1,207 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 640x360
+#sar 0: 0/1
+#tb 1: 1/48000
+#media_type 1: audio
+#codec_id 1: pcm_s24le
+#sample_rate 1: 48000
+#channel_layout_name 1: stereo
+0,          0,          0,        1,  1382400, 0x6a2c410c
+1,          0,          0,     1920,    11520, 0x974f4bab
+1,       1920,       1920,     1920,    11520, 0xdf793f69
+0,          1,          1,        1,  1382400, 0x5f0c67d2
+1,       3840,       3840,     1920,    11520, 0xfd69559a
+0,          2,          2,        1,  1382400, 0x408e1262
+1,       5760,       5760,     1920,    11520, 0x28fa469b
+0,          3,          3,        1,  1382400, 0x3567d455
+1,       7680,       7680,     1920,    11520, 0xe49161cf
+0,          4,          4,        1,  1382400, 0x2312e68b
+1,       9600,       9600,     1920,    11520, 0xb92c49ae
+0,          5,          5,        1,  1382400, 0xe3d84ec2
+1,      11520,      11520,     1920,    11520, 0xd2b75d46
+0,          6,          6,        1,  1382400, 0xdbb3ab8c
+1,      13440,      13440,     1920,    11520, 0xa13b5a9b
+0,          7,          7,        1,  1382400, 0xeb250513
+1,      15360,      15360,     1920,    11520, 0xfe804299
+0,          8,          8,        1,  1382400, 0x26c3c8c0
+1,      17280,      17280,     1920,    11520, 0x7a8654d4
+0,          9,          9,        1,  1382400, 0xbc41a23e
+1,      19200,      19200,     1920,    11520, 0x1a2e48a4
+0,         10,         10,        1,  1382400, 0x49d6a8de
+1,      21120,      21120,     1920,    11520, 0x20504669
+0,         11,         11,        1,  1382400, 0x5e05cfa4
+1,      23040,      23040,      960,     5760, 0x74bf38f6
+0,         12,         12,        1,  1382400, 0x01327a34
+1,      24000,      24000,     1920,    11520, 0x974f4bab
+1,      25920,      25920,     1920,    11520, 0xdf793f69
+0,         13,         13,        1,  1382400, 0x06ce3c36
+1,      27840,      27840,     1920,    11520, 0xfd69559a
+0,         14,         14,        1,  1382400, 0x6aa24e6c
+1,      29760,      29760,     1920,    11520, 0x28fa469b
+0,         15,         15,        1,  1382400, 0x55d8b694
+1,      31680,      31680,     1920,    11520, 0xe49161cf
+0,         16,         16,        1,  1382400, 0xcc6f136d
+1,      33600,      33600,     1920,    11520, 0xb92c49ae
+0,         17,         17,        1,  1382400, 0xe92b6ce5
+1,      35520,      35520,     1920,    11520, 0xd2b75d46
+0,         18,         18,        1,  1382400, 0x664d30a1
+1,      37440,      37440,     1920,    11520, 0xa13b5a9b
+0,         19,         19,        1,  1382400, 0x09d80a1f
+1,      39360,      39360,     1920,    11520, 0xfe804299
+0,         20,         20,        1,  1382400, 0x2b58536e
+1,      41280,      41280,     1920,    11520, 0x7a8654d4
+0,         21,         21,        1,  1382400, 0xf24b7a34
+1,      43200,      43200,     1920,    11520, 0x1a2e48a4
+0,         22,         22,        1,  1382400, 0xe2a524c4
+1,      45120,      45120,     1920,    11520, 0x20504669
+0,         23,         23,        1,  1382400, 0xe841e6b7
+1,      47040,      47040,     1920,    11520, 0x7ad44ba6
+0,         24,         24,        1,  1382400, 0x6a2c410c
+1,      48960,      48960,     1920,    11520, 0xc8934994
+0,         25,         25,        1,  1382400, 0x5f0c67d2
+1,      50880,      50880,     1920,    11520, 0x07ad70bb
+0,         26,         26,        1,  1382400, 0x408e1262
+1,      52800,      52800,     1920,    11520, 0x1ba75d9a
+0,         27,         27,        1,  1382400, 0x3567d455
+1,      54720,      54720,     1920,    11520, 0x0d4a435f
+0,         28,         28,        1,  1382400, 0x2312e68b
+1,      56640,      56640,     1920,    11520, 0x288b6c85
+0,         29,         29,        1,  1382400, 0xe3d84ec2
+1,      58560,      58560,     1920,    11520, 0x85da5f6e
+0,         30,         30,        1,  1382400, 0xdbb3ab8c
+1,      60480,      60480,     1920,    11520, 0x317a6ac0
+0,         31,         31,        1,  1382400, 0xeb250513
+1,      62400,      62400,     1920,    11520, 0xeea55aa3
+0,         32,         32,        1,  1382400, 0x26c3c8c0
+1,      64320,      64320,     1920,    11520, 0x598b604c
+0,         33,         33,        1,  1382400, 0xbc41a23e
+1,      66240,      66240,     1920,    11520, 0xbf6f4b95
+0,         34,         34,        1,  1382400, 0x49d6a8de
+1,      68160,      68160,     1920,    11520, 0x52e66e81
+0,         35,         35,        1,  1382400, 0x5e05cfa4
+1,      70080,      70080,     1920,    11520, 0xca9b57c9
+0,         36,         36,        1,  1382400, 0x01327a34
+1,      72000,      72000,     1920,    11520, 0x974f4bab
+1,      73920,      73920,     1920,    11520, 0xdf793f69
+0,         37,         37,        1,  1382400, 0x06ce3c36
+1,      75840,      75840,     1920,    11520, 0xfd69559a
+0,         38,         38,        1,  1382400, 0x6aa24e6c
+1,      77760,      77760,     1920,    11520, 0x28fa469b
+0,         39,         39,        1,  1382400, 0x55d8b694
+1,      79680,      79680,     1920,    11520, 0xe49161cf
+0,         40,         40,        1,  1382400, 0xcc6f136d
+1,      81600,      81600,     1920,    11520, 0xb92c49ae
+0,         41,         41,        1,  1382400, 0xe92b6ce5
+1,      83520,      83520,     1920,    11520, 0xd2b75d46
+0,         42,         42,        1,  1382400, 0x664d30a1
+1,      85440,      85440,     1920,    11520, 0xa13b5a9b
+0,         43,         43,        1,  1382400, 0x09d80a1f
+1,      87360,      87360,     1920,    11520, 0xfe804299
+0,         44,         44,        1,  1382400, 0x2b58536e
+1,      89280,      89280,     1920,    11520, 0x7a8654d4
+0,         45,         45,        1,  1382400, 0xf24b7a34
+1,      91200,      91200,     1920,    11520, 0x1a2e48a4
+0,         46,         46,        1,  1382400, 0xe2a524c4
+1,      93120,      93120,     1920,    11520, 0x20504669
+0,         47,         47,        1,  1382400, 0xe841e6b7
+1,      95040,      95040,     1920,    11520, 0x7ad44ba6
+0,         48,         48,        1,  1382400, 0x6a2c410c
+1,      96960,      96960,     1920,    11520, 0xc8934994
+0,         49,         49,        1,  1382400, 0x5f0c67d2
+1,      98880,      98880,     1920,    11520, 0x07ad70bb
+0,         50,         50,        1,  1382400, 0x408e1262
+1,     100800,     100800,     1920,    11520, 0x1ba75d9a
+0,         51,         51,        1,  1382400, 0x3567d455
+1,     102720,     102720,     1920,    11520, 0x0d4a435f
+0,         52,         52,        1,  1382400, 0x2312e68b
+1,     104640,     104640,     1920,    11520, 0x288b6c85
+0,         53,         53,        1,  1382400, 0xe3d84ec2
+1,     106560,     106560,     1920,    11520, 0x85da5f6e
+0,         54,         54,        1,  1382400, 0xdbb3ab8c
+1,     108480,     108480,     1920,    11520, 0x317a6ac0
+0,         55,         55,        1,  1382400, 0xeb250513
+1,     110400,     110400,     1920,    11520, 0xeea55aa3
+0,         56,         56,        1,  1382400, 0x26c3c8c0
+1,     112320,     112320,     1920,    11520, 0x598b604c
+0,         57,         57,        1,  1382400, 0xbc41a23e
+1,     114240,     114240,     1760,    10560, 0x9f22893b
+0,         58,         58,        1,  1382400, 0x49d6a8de
+1,     116000,     116000,     1920,    11520, 0x974f4bab
+1,     117920,     117920,     1920,    11520, 0xdf793f69
+0,         59,         59,        1,  1382400, 0x5e05cfa4
+1,     119840,     119840,     1920,    11520, 0xfd69559a
+0,         60,         60,        1,  1382400, 0x01327a34
+1,     121760,     121760,     1920,    11520, 0x28fa469b
+0,         61,         61,        1,  1382400, 0x06ce3c36
+1,     123680,     123680,     1920,    11520, 0xe49161cf
+0,         62,         62,        1,  1382400, 0x6aa24e6c
+1,     125600,     125600,     1920,    11520, 0xb92c49ae
+0,         63,         63,        1,  1382400, 0x55d8b694
+1,     127520,     127520,     1920,    11520, 0xd2b75d46
+0,         64,         64,        1,  1382400, 0xcc6f136d
+1,     129440,     129440,     1920,    11520, 0xa13b5a9b
+0,         65,         65,        1,  1382400, 0xe92b6ce5
+1,     131360,     131360,     1920,    11520, 0xfe804299
+0,         66,         66,        1,  1382400, 0x664d30a1
+1,     133280,     133280,     1920,    11520, 0x7a8654d4
+0,         67,         67,        1,  1382400, 0x09d80a1f
+1,     135200,     135200,     1920,    11520, 0x1a2e48a4
+0,         68,         68,        1,  1382400, 0x2b58536e
+1,     137120,     137120,     1920,    11520, 0x20504669
+0,         69,         69,        1,  1382400, 0xf24b7a34
+1,     139040,     139040,     1920,    11520, 0x7ad44ba6
+0,         70,         70,        1,  1382400, 0xe2a524c4
+1,     140960,     140960,     1920,    11520, 0xc8934994
+0,         71,         71,        1,  1382400, 0xe841e6b7
+1,     142880,     142880,     1920,    11520, 0x07ad70bb
+0,         72,         72,        1,  1382400, 0x6a2c410c
+1,     144800,     144800,     1920,    11520, 0x1ba75d9a
+0,         73,         73,        1,  1382400, 0x5f0c67d2
+1,     146720,     146720,     1920,    11520, 0x0d4a435f
+0,         74,         74,        1,  1382400, 0x408e1262
+1,     148640,     148640,     1920,    11520, 0x288b6c85
+0,         75,         75,        1,  1382400, 0x3567d455
+1,     150560,     150560,     1920,    11520, 0x85da5f6e
+0,         76,         76,        1,  1382400, 0x2312e68b
+1,     152480,     152480,     1920,    11520, 0x317a6ac0
+0,         77,         77,        1,  1382400, 0xe3d84ec2
+1,     154400,     154400,     1920,    11520, 0xeea55aa3
+0,         78,         78,        1,  1382400, 0xdbb3ab8c
+1,     156320,     156320,     1920,    11520, 0x598b604c
+0,         79,         79,        1,  1382400, 0xeb250513
+1,     158240,     158240,     1920,    11520, 0xbf6f4b95
+0,         80,         80,        1,  1382400, 0x26c3c8c0
+1,     160160,     160160,     1920,    11520, 0x52e66e81
+0,         81,         81,        1,  1382400, 0xbc41a23e
+1,     162080,     162080,     1920,    11520, 0xca9b57c9
+0,         82,         82,        1,  1382400, 0x49d6a8de
+1,     164000,     164000,     1920,    11520, 0xee0035c1
+1,     165920,     165920,     1920,    11520, 0x31424265
+0,         83,         83,        1,  1382400, 0x5e05cfa4
+1,     167840,     167840,     1920,    11520, 0x035d4a8d
+0,         84,         84,        1,  1382400, 0x01327a34
+1,     169760,     169760,     1920,    11520, 0xa8375593
+0,         85,         85,        1,  1382400, 0x06ce3c36
+1,     171680,     171680,     1920,    11520, 0xbc3e65d3
+0,         86,         86,        1,  1382400, 0x6aa24e6c
+1,     173600,     173600,     1920,    11520, 0xa2083bae
+0,         87,         87,        1,  1382400, 0x55d8b694
+1,     175520,     175520,     1920,    11520, 0xa220604f
+0,         88,         88,        1,  1382400, 0xcc6f136d
+1,     177440,     177440,     1920,    11520, 0xd5d3598c
+0,         89,         89,        1,  1382400, 0xe92b6ce5
+1,     179360,     179360,     1920,    11520, 0x0e376085
+0,         90,         90,        1,  1382400, 0x664d30a1
+1,     181280,     181280,     1920,    11520, 0x40d973bf
+0,         91,         91,        1,  1382400, 0x09d80a1f
+1,     183200,     183200,     1920,    11520, 0x05d74496
+0,         92,         92,        1,  1382400, 0x2b58536e
+1,     185120,     185120,     1920,    11520, 0xec735e54
+0,         93,         93,        1,  1382400, 0xf24b7a34
+1,     187040,     187040,     1920,    11520, 0x485c5a96
+0,         94,         94,        1,  1382400, 0xe2a524c4
+1,     188960,     188960,     1920,    11520, 0x0ec2705d
+0,         95,         95,        1,  1382400, 0xe841e6b7
+1,     190880,     190880,     1120,     6720, 0x81991480