diff --git a/tests/ref/fate/matroska-dvbsub-remux b/tests/ref/fate/matroska-dvbsub-remux
index b7346b8f55..16e5ce9a34 100644
--- a/tests/ref/fate/matroska-dvbsub-remux
+++ b/tests/ref/fate/matroska-dvbsub-remux
@@ -8,45 +8,45 @@
 #tb 1: 1/1000
 #media_type 1: subtitle
 #codec_id 1: dvb_subtitle
-0,          0,          0,      280,       14, 0x05f400e1
-1,          0,          0,        0,       14, 0x05f400e1
-0,        280,        280,     5000,       14, 0x066400f1
-1,        280,        280,        0,       14, 0x066400f1
-0,       5280,       5280,     5020,       14, 0x06d40101
-1,       5280,       5280,        0,       14, 0x06d40101
-0,      10300,      10300,     3600,       14, 0x07440111
-1,      10300,      10300,        0,       14, 0x07440111
-0,      13900,      13900,      220,       14, 0x07b40121
-1,      13900,      13900,        0,       14, 0x07b40121
-0,      14120,      14120,     1440,       14, 0x08240131
-1,      14120,      14120,        0,       14, 0x08240131
-0,      15560,      15560,       40,       14, 0x08940141
-1,      15560,      15560,        0,       14, 0x08940141
-0,      15600,      15600,      160,      944, 0x454c0939
-1,      15600,      15600,        0,      944, 0x454c0939
-0,      15760,      15760,      240,      630, 0x49dbb35f
-1,      15760,      15760,        0,      630, 0x49dbb35f
-0,      16000,      16000,      340,      344, 0xb1eb63ed
-1,      16000,      16000,        0,      344, 0xb1eb63ed
-0,      16340,      16340,      600,      966, 0xb8a61edf
-1,      16340,      16340,        0,      966, 0xb8a61edf
-0,      16940,      16940,      460,      470, 0x80597fba
-1,      16940,      16940,        0,      470, 0x80597fba
-0,      17400,      17400,      360,     1212, 0x554768d6
-1,      17400,      17400,        0,     1212, 0x554768d6
-0,      17760,      17760,      220,     4804, 0xab67ddbe
-1,      17760,      17760,        0,     4804, 0xab67ddbe
-0,      17980,      17980,      960,     1016, 0x15e42d56
-1,      17980,      17980,        0,     1016, 0x15e42d56
-0,      18940,      18940,      220,      456, 0x57917e6f
-1,      18940,      18940,        0,      456, 0x57917e6f
-0,      19160,      19160,      260,      830, 0xcff3efde
-1,      19160,      19160,        0,      830, 0xcff3efde
-0,      19420,      19420,      100,      860, 0xd89903b6
-1,      19420,      19420,        0,      860, 0xd89903b6
-0,      19520,      19520,      220,     4426, 0x01eb43f1
-1,      19520,      19520,        0,     4426, 0x01eb43f1
-0,      19740,      19740,      220,     1132, 0xedda51a8
-1,      19740,      19740,        0,     1132, 0xedda51a8
-0,      19960,      19960,        0,      466, 0x9c957e09
-1,      19960,      19960,        0,      466, 0x9c957e09
+0,          0,          0,      280,       14, 0x05f400e1, F=0x21
+1,          0,          0,        0,       14, 0x05f400e1, F=0x21
+0,        280,        280,     5000,       14, 0x066400f1, F=0x21
+1,        280,        280,        0,       14, 0x066400f1, F=0x21
+0,       5280,       5280,     5020,       14, 0x06d40101, F=0x21
+1,       5280,       5280,        0,       14, 0x06d40101, F=0x21
+0,      10300,      10300,     3600,       14, 0x07440111, F=0x21
+1,      10300,      10300,        0,       14, 0x07440111, F=0x21
+0,      13900,      13900,      220,       14, 0x07b40121, F=0x21
+1,      13900,      13900,        0,       14, 0x07b40121, F=0x21
+0,      14120,      14120,     1440,       14, 0x08240131, F=0x21
+1,      14120,      14120,        0,       14, 0x08240131, F=0x21
+0,      15560,      15560,       40,       14, 0x08940141, F=0x21
+1,      15560,      15560,        0,       14, 0x08940141, F=0x21
+0,      15600,      15600,      160,      944, 0x454c0939, F=0x21
+1,      15600,      15600,        0,      944, 0x454c0939, F=0x21
+0,      15760,      15760,      240,      630, 0x49dbb35f, F=0x21
+1,      15760,      15760,        0,      630, 0x49dbb35f, F=0x21
+0,      16000,      16000,      340,      344, 0xb1eb63ed, F=0x21
+1,      16000,      16000,        0,      344, 0xb1eb63ed, F=0x21
+0,      16340,      16340,      600,      966, 0xb8a61edf, F=0x21
+1,      16340,      16340,        0,      966, 0xb8a61edf, F=0x21
+0,      16940,      16940,      460,      470, 0x80597fba, F=0x21
+1,      16940,      16940,        0,      470, 0x80597fba, F=0x21
+0,      17400,      17400,      360,     1212, 0x554768d6, F=0x21
+1,      17400,      17400,        0,     1212, 0x554768d6, F=0x21
+0,      17760,      17760,      220,     4804, 0xab67ddbe, F=0x21
+1,      17760,      17760,        0,     4804, 0xab67ddbe, F=0x21
+0,      17980,      17980,      960,     1016, 0x15e42d56, F=0x21
+1,      17980,      17980,        0,     1016, 0x15e42d56, F=0x21
+0,      18940,      18940,      220,      456, 0x57917e6f, F=0x21
+1,      18940,      18940,        0,      456, 0x57917e6f, F=0x21
+0,      19160,      19160,      260,      830, 0xcff3efde, F=0x21
+1,      19160,      19160,        0,      830, 0xcff3efde, F=0x21
+0,      19420,      19420,      100,      860, 0xd89903b6, F=0x21
+1,      19420,      19420,        0,      860, 0xd89903b6, F=0x21
+0,      19520,      19520,      220,     4426, 0x01eb43f1, F=0x21
+1,      19520,      19520,        0,     4426, 0x01eb43f1, F=0x21
+0,      19740,      19740,      220,     1132, 0xedda51a8, F=0x21
+1,      19740,      19740,        0,     1132, 0xedda51a8, F=0x21
+0,      19960,      19960,        0,      466, 0x9c957e09, F=0x21
+1,      19960,      19960,        0,      466, 0x9c957e09, F=0x21
diff --git a/tests/ref/fate/matroska-zero-length-block b/tests/ref/fate/matroska-zero-length-block
index bef887d58b..f7799a9881 100644
--- a/tests/ref/fate/matroska-zero-length-block
+++ b/tests/ref/fate/matroska-zero-length-block
@@ -3,8 +3,8 @@ d9c8efb9d64addce3cac97e6c417d985 *tests/data/fate/matroska-zero-length-block.mat
 #tb 0: 1/1000
 #media_type 0: subtitle
 #codec_id 0: subrip
-0,       1000,       1000,     2000,        5, 0x05b801df
-0,       3300,       3300,     3700,       16, 0x300705b2
+0,       1000,       1000,     2000,        5, 0x05b801df, F=0x21
+0,       3300,       3300,     3700,       16, 0x300705b2, F=0x21
 [STREAM]
 TAG:DESCRIPTION=This track uses header removal compression and has a Block of size zero before reversing it.
 [/STREAM]
diff --git a/tests/ref/fate/matroska-zlib-decompression b/tests/ref/fate/matroska-zlib-decompression
index 0ea732346a..d830f3cf75 100644
--- a/tests/ref/fate/matroska-zlib-decompression
+++ b/tests/ref/fate/matroska-zlib-decompression
@@ -2,4 +2,4 @@
 #tb 0: 1/1000
 #media_type 0: subtitle
 #codec_id 0: dvd_subtitle
-0,       1000,       1000,     1991,      191, 0x52f74934
+0,       1000,       1000,     1991,      191, 0x52f74934, F=0x21
diff --git a/tests/ref/fate/shortest-sub b/tests/ref/fate/shortest-sub
index 53f89925b9..3987ddd2f5 100644
--- a/tests/ref/fate/shortest-sub
+++ b/tests/ref/fate/shortest-sub
@@ -142,7 +142,7 @@
 0,     130000,     130000,     1000,        3, 0x00000000
 0,     131000,     131000,     1000,        3, 0x00000000
 0,     132000,     132000,     1000,        3, 0x00000000
-1,     132499,     132499,        0,     2238, 0xf8f81348
+1,     132499,     132499,        0,     2238, 0xf8f81348, F=0x21
 0,     133000,     133000,     1000,        3, 0x00000000
 0,     134000,     134000,     1000,        3, 0x00000000
 0,     135000,     135000,     1000,        3, 0x00000000
@@ -158,7 +158,7 @@
 0,     145000,     145000,     1000,        3, 0x00000000
 0,     146000,     146000,     1000,        3, 0x00000000
 0,     147000,     147000,     1000,        3, 0x00000000
-1,     147355,     147355,        0,     3320, 0x7091f477
+1,     147355,     147355,        0,     3320, 0x7091f477, F=0x21
 0,     148000,     148000,     1000,        3, 0x00000000
 0,     149000,     149000,     1000,        3, 0x00000000
 0,     150000,     150000,     1000,        3, 0x00000000
@@ -192,22 +192,22 @@
 0,     178000,     178000,     1000,        3, 0x00000000
 0,     179000,     179000,     1000,        3, 0x00000000
 0,     180000,     180000,     1000,        3, 0x00000000
-1,     180797,     180797,        0,     3626, 0xe4ff6eab
+1,     180797,     180797,        0,     3626, 0xe4ff6eab, F=0x21
 0,     181000,     181000,     1000,        3, 0x00000000
 0,     182000,     182000,     1000,        3, 0x00000000
 0,     183000,     183000,     1000,        3, 0x00000000
-1,     183433,     183433,        0,     4156, 0xc73645fe
+1,     183433,     183433,        0,     4156, 0xc73645fe, F=0x21
 0,     184000,     184000,     1000,        3, 0x00000000
 0,     185000,     185000,     1000,        3, 0x00000000
-1,     185919,     185919,        0,     2019, 0xe9a5f34f
-1,     185919,     185919,        0,     1213, 0x8a62d853
+1,     185919,     185919,        0,     2019, 0xe9a5f34f, F=0x21
+1,     185919,     185919,        0,     1213, 0x8a62d853, F=0x21
 0,     186000,     186000,     1000,        3, 0x00000000
 0,     187000,     187000,     1000,        3, 0x00000000
 0,     188000,     188000,     1000,        3, 0x00000000
-1,     188663,     188663,        0,     2184, 0xfdcd0323
+1,     188663,     188663,        0,     2184, 0xfdcd0323, F=0x21
 0,     189000,     189000,     1000,        3, 0x00000000
 0,     190000,     190000,     1000,        3, 0x00000000
-1,     190014,     190014,        0,     2172, 0xb479f0a1
+1,     190014,     190014,        0,     2172, 0xb479f0a1, F=0x21
 0,     191000,     191000,     1000,        3, 0x00000000
 0,     192000,     192000,     1000,        3, 0x00000000
 0,     193000,     193000,     1000,        3, 0x00000000
@@ -217,64 +217,64 @@
 0,     197000,     197000,     1000,        3, 0x00000000
 0,     198000,     198000,     1000,        3, 0x00000000
 0,     199000,     199000,     1000,        3, 0x00000000
-1,     199724,     199724,        0,     2080, 0xe8e7c3a2
+1,     199724,     199724,        0,     2080, 0xe8e7c3a2, F=0x21
 0,     200000,     200000,     1000,        3, 0x00000000
 0,     201000,     201000,     1000,        3, 0x00000000
-1,     201175,     201175,        0,     1972, 0xd2c87cd0
+1,     201175,     201175,        0,     1972, 0xd2c87cd0, F=0x21
 0,     202000,     202000,     1000,        3, 0x00000000
-1,     202819,     202819,        0,     2856, 0xc9a42a11
+1,     202819,     202819,        0,     2856, 0xc9a42a11, F=0x21
 0,     203000,     203000,     1000,        3, 0x00000000
 0,     204000,     204000,     1000,        3, 0x00000000
-1,     204762,     204762,        0,     3570, 0x02035220
+1,     204762,     204762,        0,     3570, 0x02035220, F=0x21
 0,     205000,     205000,     1000,        3, 0x00000000
 0,     206000,     206000,     1000,        3, 0x00000000
-1,     206806,     206806,        0,     3270, 0x9a39c179
+1,     206806,     206806,        0,     3270, 0x9a39c179, F=0x21
 0,     207000,     207000,     1000,        3, 0x00000000
 0,     208000,     208000,     1000,        3, 0x00000000
-1,     208716,     208716,        0,     2968, 0x6c0b46de
+1,     208716,     208716,        0,     2968, 0x6c0b46de, F=0x21
 0,     209000,     209000,     1000,        3, 0x00000000
 0,     210000,     210000,     1000,        3, 0x00000000
-1,     210051,     210051,        0,     2142, 0x9e64e867
+1,     210051,     210051,        0,     2142, 0x9e64e867, F=0x21
 0,     211000,     211000,     1000,        3, 0x00000000
-1,     211644,     211644,        0,     4060, 0x274516cc
+1,     211644,     211644,        0,     4060, 0x274516cc, F=0x21
 0,     212000,     212000,     1000,        3, 0x00000000
 0,     213000,     213000,     1000,        3, 0x00000000
 0,     214000,     214000,     1000,        3, 0x00000000
-1,     214380,     214380,        0,     4214, 0xa6a068cb
+1,     214380,     214380,        0,     4214, 0xa6a068cb, F=0x21
 0,     215000,     215000,     1000,        3, 0x00000000
 0,     216000,     216000,     1000,        3, 0x00000000
 0,     217000,     217000,     1000,        3, 0x00000000
-1,     217225,     217225,        0,     3770, 0x3d3aaf6c
+1,     217225,     217225,        0,     3770, 0x3d3aaf6c, F=0x21
 0,     218000,     218000,     1000,        3, 0x00000000
 0,     219000,     219000,     1000,        3, 0x00000000
-1,     219652,     219652,        0,     1862, 0xaa9a5a30
+1,     219652,     219652,        0,     1862, 0xaa9a5a30, F=0x21
 0,     220000,     220000,     1000,        3, 0x00000000
 0,     221000,     221000,     1000,        3, 0x00000000
 0,     222000,     222000,     1000,        3, 0x00000000
 0,     223000,     223000,     1000,        3, 0x00000000
-1,     223531,     223531,        0,     3222, 0x390690fb
+1,     223531,     223531,        0,     3222, 0x390690fb, F=0x21
 0,     224000,     224000,     1000,        3, 0x00000000
 0,     225000,     225000,     1000,        3, 0x00000000
 0,     226000,     226000,     1000,        3, 0x00000000
 0,     227000,     227000,     1000,        3, 0x00000000
-1,     227510,     227510,        0,     4064, 0x13e132a4
+1,     227510,     227510,        0,     4064, 0x13e132a4, F=0x21
 0,     228000,     228000,     1000,        3, 0x00000000
 0,     229000,     229000,     1000,        3, 0x00000000
 0,     230000,     230000,     1000,        3, 0x00000000
-1,     230872,     230872,        0,     3010, 0xc4a07cbd
+1,     230872,     230872,        0,     3010, 0xc4a07cbd, F=0x21
 0,     231000,     231000,     1000,        3, 0x00000000
 0,     232000,     232000,     1000,        3, 0x00000000
 0,     233000,     233000,     1000,        3, 0x00000000
-1,     233124,     233124,        0,     4950, 0xd30b9b64
+1,     233124,     233124,        0,     4950, 0xd30b9b64, F=0x21
 0,     234000,     234000,     1000,        3, 0x00000000
 0,     235000,     235000,     1000,        3, 0x00000000
 0,     236000,     236000,     1000,        3, 0x00000000
 0,     237000,     237000,     1000,        3, 0x00000000
-1,     237303,     237303,        0,     4184, 0x5115659c
+1,     237303,     237303,        0,     4184, 0x5115659c, F=0x21
 0,     238000,     238000,     1000,        3, 0x00000000
 0,     239000,     239000,     1000,        3, 0x00000000
 0,     240000,     240000,     1000,        3, 0x00000000
-1,     240106,     240106,        0,     3554, 0x14804a6c
+1,     240106,     240106,        0,     3554, 0x14804a6c, F=0x21
 0,     241000,     241000,     1000,        3, 0x00000000
 0,     242000,     242000,     1000,        3, 0x00000000
 0,     243000,     243000,     1000,        3, 0x00000000
@@ -308,7 +308,7 @@
 0,     271000,     271000,     1000,        3, 0x00000000
 0,     272000,     272000,     1000,        3, 0x00000000
 0,     273000,     273000,     1000,        3, 0x00000000
-1,     273556,     273556,        0,     2300, 0x53d23a41
+1,     273556,     273556,        0,     2300, 0x53d23a41, F=0x21
 0,     274000,     274000,     1000,        3, 0x00000000
 0,     275000,     275000,     1000,        3, 0x00000000
 0,     276000,     276000,     1000,        3, 0x00000000
@@ -331,25 +331,25 @@
 0,     293000,     293000,     1000,        3, 0x00000000
 0,     294000,     294000,     1000,        3, 0x00000000
 0,     295000,     295000,     1000,        3, 0x00000000
-1,     295445,     295445,        0,     1544, 0x4e4ed1a0
+1,     295445,     295445,        0,     1544, 0x4e4ed1a0, F=0x21
 0,     296000,     296000,     1000,        3, 0x00000000
 0,     297000,     297000,     1000,        3, 0x00000000
 0,     298000,     298000,     1000,        3, 0x00000000
 0,     299000,     299000,     1000,        3, 0x00000000
 0,     300000,     300000,     1000,        3, 0x00000000
-1,     300049,     300049,        0,     2478, 0x6e3e7b4d
+1,     300049,     300049,        0,     2478, 0x6e3e7b4d, F=0x21
 0,     301000,     301000,     1000,        3, 0x00000000
 0,     302000,     302000,     1000,        3, 0x00000000
-1,     302018,     302018,        0,     2019, 0x5eb7c3d9
-1,     302035,     302035,        0,      405, 0x98a58922
+1,     302018,     302018,        0,     2019, 0x5eb7c3d9, F=0x21
+1,     302035,     302035,        0,      405, 0x98a58922, F=0x21
 0,     303000,     303000,     1000,        3, 0x00000000
 0,     304000,     304000,     1000,        3, 0x00000000
-1,     304203,     304203,        0,     2998, 0xee7c6a15
+1,     304203,     304203,        0,     2998, 0xee7c6a15, F=0x21
 0,     305000,     305000,     1000,        3, 0x00000000
-1,     305947,     305947,        0,     2640, 0xf426b974
+1,     305947,     305947,        0,     2640, 0xf426b974, F=0x21
 0,     306000,     306000,     1000,        3, 0x00000000
 0,     307000,     307000,     1000,        3, 0x00000000
-1,     307957,     307957,        0,     2174, 0x40340514
+1,     307957,     307957,        0,     2174, 0x40340514, F=0x21
 0,     308000,     308000,     1000,        3, 0x00000000
 0,     309000,     309000,     1000,        3, 0x00000000
 0,     310000,     310000,     1000,        3, 0x00000000
@@ -364,26 +364,26 @@
 0,     319000,     319000,     1000,        3, 0x00000000
 0,     320000,     320000,     1000,        3, 0x00000000
 0,     321000,     321000,     1000,        3, 0x00000000
-1,     321295,     321295,        0,     2760, 0x4ae1e9ad
+1,     321295,     321295,        0,     2760, 0x4ae1e9ad, F=0x21
 0,     322000,     322000,     1000,        3, 0x00000000
 0,     323000,     323000,     1000,        3, 0x00000000
-1,     323356,     323356,        0,     2688, 0xdec1c1d6
+1,     323356,     323356,        0,     2688, 0xdec1c1d6, F=0x21
 0,     324000,     324000,     1000,        3, 0x00000000
-1,     324640,     324640,        0,     3694, 0x3b5d80de
+1,     324640,     324640,        0,     3694, 0x3b5d80de, F=0x21
 0,     325000,     325000,     1000,        3, 0x00000000
 0,     326000,     326000,     1000,        3, 0x00000000
 0,     327000,     327000,     1000,        3, 0x00000000
-1,     327193,     327193,        0,     2276, 0x0dae2c53
+1,     327193,     327193,        0,     2276, 0x0dae2c53, F=0x21
 0,     328000,     328000,     1000,        3, 0x00000000
-1,     328369,     328369,        0,     2019, 0x4d9cd2f2
-1,     328369,     328369,        0,      847, 0x1d3f4a3d
+1,     328369,     328369,        0,     2019, 0x4d9cd2f2, F=0x21
+1,     328369,     328369,        0,      847, 0x1d3f4a3d, F=0x21
 0,     329000,     329000,     1000,        3, 0x00000000
-1,     329946,     329946,        0,     1974, 0xb63e71b1
+1,     329946,     329946,        0,     1974, 0xb63e71b1, F=0x21
 0,     330000,     330000,     1000,        3, 0x00000000
 0,     331000,     331000,     1000,        3, 0x00000000
-1,     331230,     331230,        0,     3004, 0x69a86a37
+1,     331230,     331230,        0,     3004, 0x69a86a37, F=0x21
 0,     332000,     332000,     1000,        3, 0x00000000
-1,     332924,     332924,        0,     2124, 0xf5c6dc9a
+1,     332924,     332924,        0,     2124, 0xf5c6dc9a, F=0x21
 0,     333000,     333000,     1000,        3, 0x00000000
 0,     334000,     334000,     1000,        3, 0x00000000
 0,     335000,     335000,     1000,        3, 0x00000000
@@ -394,12 +394,12 @@
 0,     340000,     340000,     1000,        3, 0x00000000
 0,     341000,     341000,     1000,        3, 0x00000000
 0,     342000,     342000,     1000,        3, 0x00000000
-1,     342600,     342600,        0,     1876, 0x3ed26066
+1,     342600,     342600,        0,     1876, 0x3ed26066, F=0x21
 0,     343000,     343000,     1000,        3, 0x00000000
 0,     344000,     344000,     1000,        3, 0x00000000
 0,     345000,     345000,     1000,        3, 0x00000000
 0,     346000,     346000,     1000,        3, 0x00000000
-1,     346771,     346771,        0,     2426, 0xccae6c39
+1,     346771,     346771,        0,     2426, 0xccae6c39, F=0x21
 0,     347000,     347000,     1000,        3, 0x00000000
 0,     348000,     348000,     1000,        3, 0x00000000
 0,     349000,     349000,     1000,        3, 0x00000000
@@ -411,7 +411,7 @@
 0,     355000,     355000,     1000,        3, 0x00000000
 0,     356000,     356000,     1000,        3, 0x00000000
 0,     357000,     357000,     1000,        3, 0x00000000
-1,     357640,     357640,        0,     3240, 0x90cb9fd1
+1,     357640,     357640,        0,     3240, 0x90cb9fd1, F=0x21
 0,     358000,     358000,     1000,        3, 0x00000000
 0,     359000,     359000,     1000,        3, 0x00000000
-1,     359834,     359834,        0,     2482, 0xc68e6a8a
+1,     359834,     359834,        0,     2482, 0xc68e6a8a, F=0x21