diff --git a/tests/fate/h264.mak b/tests/fate/h264.mak
index 173806861a..cd2ad79ea2 100644
--- a/tests/fate/h264.mak
+++ b/tests/fate/h264.mak
@@ -232,6 +232,7 @@ FATE_H264-$(call FRAMECRC, MOV, H264) += fate-h264-attachment-631
 FATE_H264-$(call FRAMECRC, MPEGTS, H264, H264_PARSER MP3_DECODER SCALE_FILTER ARESAMPLE_FILTER) += fate-h264-skip-nokey fate-h264-skip-nointra
 FATE_H264_FFPROBE-$(call DEMDEC, MATROSKA, H264) += fate-h264-dts_5frames
 FATE_H264_FFPROBE-$(call PARSERDEMDEC, H264, H264, H264) += fate-h264-afd
+FATE_H264_FFPROBE-$(call PARSERDEMDEC, H264, H264, H264) += fate-h264-no-cropping
 
 FATE_SAMPLES_AVCONV += $(FATE_H264-yes)
 FATE_SAMPLES_FFPROBE += $(FATE_H264_FFPROBE-yes)
@@ -452,6 +453,9 @@ fate-h264-reinit-%:                               CMD = framecrc -i $(TARGET_SAM
 
 fate-h264-dts_5frames:                            CMD = probeframes $(TARGET_SAMPLES)/h264/dts_5frames.mkv
 fate-h264-afd:                                    CMD = run ffprobe$(PROGSSUF)$(EXESUF) -bitexact -show_entries frame_side_data_list $(TARGET_SAMPLES)/h264/bbc2.sample.h264
+fate-h264-no-cropping:                            CMD = run ffprobe$(PROGSSUF)$(EXESUF) -bitexact -apply_cropping 0 -show_entries stream=width,height,coded_width,coded_height \
+                                                                                        -show_entries frame=width,height,crop_top,crop_bottom,crop_left,crop_right \
+                                                                                        -of compact=p=0 -i $(TARGET_SAMPLES)/h264/bbc2.sample.h264
 
 fate-h264-encparams: CMD = venc_data $(TARGET_SAMPLES)/h264-conformance/FRext/FRExt_MMCO4_Sony_B.264 0 1
 FATE_SAMPLES_DUMP_DATA += fate-h264-encparams
diff --git a/tests/ref/fate/h264-no-cropping b/tests/ref/fate/h264-no-cropping
new file mode 100644
index 0000000000..84669ab733
--- /dev/null
+++ b/tests/ref/fate/h264-no-cropping
@@ -0,0 +1,95 @@
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1088|crop_top=0|crop_bottom=8|crop_left=0|crop_right=0|
+
+width=1440|height=1080|coded_width=1440|coded_height=1088