diff --git a/tests/fate/ffmpeg.mak b/tests/fate/ffmpeg.mak
index 87cd0b46d0..763ed381ee 100644
--- a/tests/fate/ffmpeg.mak
+++ b/tests/fate/ffmpeg.mak
@@ -132,9 +132,12 @@ fate-ffmpeg-fix_sub_duration_heartbeat: CMD = fmtstdout srt -fix_sub_duration \
   -c:s srt \
   -f null -
 
-FATE_SAMPLES_FFMPEG-$(call FRAMECRC, MATROSKA, H264 AAC_FIXED, PCM_S32LE_ENCODER) += fate-ffmpeg-streamloop-transcode-av
+# FIXME: the integer AAC decoder does not produce the same output on all platforms
+# so until that is fixed we use the volume filter to silence the data
+FATE_SAMPLES_FFMPEG-$(call FRAMECRC, MATROSKA, H264 AAC_FIXED, PCM_S32LE_ENCODER VOLUME_FILTER) += fate-ffmpeg-streamloop-transcode-av
 fate-ffmpeg-streamloop-transcode-av: CMD = \
-	framecrc -auto_conversion_filters -stream_loop 3 -i $(TARGET_SAMPLES)/mkv/1242-small.mkv -c:a pcm_s32le
+    framecrc -auto_conversion_filters -stream_loop 3 -c:a aac_fixed -i $(TARGET_SAMPLES)/mkv/1242-small.mkv \
+    -af volume=0 -c:a pcm_s32le
 
 FATE_STREAMCOPY-$(call REMUX, MP4 MOV, EAC3_DEMUXER) += fate-copy-trac3074
 fate-copy-trac3074: CMD = transcode eac3 $(TARGET_SAMPLES)/eac3/csi_miami_stereo_128_spx.eac3\
diff --git a/tests/ref/fate/ffmpeg-streamloop-transcode-av b/tests/ref/fate/ffmpeg-streamloop-transcode-av
index 50a626b281..6934e39d41 100644
--- a/tests/ref/fate/ffmpeg-streamloop-transcode-av
+++ b/tests/ref/fate/ffmpeg-streamloop-transcode-av
@@ -18,31 +18,31 @@
 1,       4072,       4072,     1024,     8192, 0x00000000
 1,       5096,       5096,     1024,     8192, 0x00000000
 0,          3,          3,        1,  1378560, 0xca1deba8
-1,       6120,       6120,     1024,     8192, 0x687330d2
-1,       7128,       7128,     1024,     8192, 0x9131462c
+1,       6120,       6120,     1024,     8192, 0x00000000
+1,       7128,       7128,     1024,     8192, 0x00000000
 0,          4,          4,        1,  1378560, 0xd4eed467
-1,       8208,       8208,     1024,     8192, 0x48c01c32
-1,       9232,       9232,     1024,     8192, 0x0ccd8d5f
+1,       8208,       8208,     1024,     8192, 0x00000000
+1,       9232,       9232,     1024,     8192, 0x00000000
 0,          5,          5,        1,  1378560, 0xd6e1d5b7
-1,      10248,      10248,     1024,     8192, 0xd50cbe9f
-1,      11256,      11256,     1024,     8192, 0xbe069303
+1,      10248,      10248,     1024,     8192, 0x00000000
+1,      11256,      11256,     1024,     8192, 0x00000000
 0,          6,          6,        1,  1378560, 0x0b574d39
-1,      12280,      12280,     1024,     8192, 0x85fccf5b
-1,      13304,      13304,     1024,     8192, 0x4180de71
+1,      12280,      12280,     1024,     8192, 0x00000000
+1,      13304,      13304,     1024,     8192, 0x00000000
 0,          7,          7,        1,  1378560, 0x1bdd4d61
-1,      14328,      14328,     1024,     8192, 0x0e9b6ac3
-1,      15336,      15336,     1024,     8192, 0x5c33f724
+1,      14328,      14328,     1024,     8192, 0x00000000
+1,      15336,      15336,     1024,     8192, 0x00000000
 0,          8,          8,        1,  1378560, 0x3b28f549
-1,      16360,      16360,     1024,     8192, 0x668aaaec
-1,      17384,      17384,     1024,     8192, 0xd137d412
+1,      16360,      16360,     1024,     8192, 0x00000000
+1,      17384,      17384,     1024,     8192, 0x00000000
 0,          9,          9,        1,  1378560, 0x45b2f57b
-1,      18408,      18408,     1024,     8192, 0x08e1fbf6
-1,      19416,      19416,     1024,     8192, 0xbf3fb4f6
+1,      18408,      18408,     1024,     8192, 0x00000000
+1,      19416,      19416,     1024,     8192, 0x00000000
 0,         10,         10,        1,  1378560, 0x8955570e
-1,      20440,      20440,     1024,     8192, 0x69cd08a4
-1,      21464,      21464,     1024,     8192, 0xe0fe6297
-1,      22488,      22488,     1024,     8192, 0x172867ad
-1,      23496,      23496,     1024,     8192, 0xcbcc1461
+1,      20440,      20440,     1024,     8192, 0x00000000
+1,      21464,      21464,     1024,     8192, 0x00000000
+1,      22488,      22488,     1024,     8192, 0x00000000
+1,      23496,      23496,     1024,     8192, 0x00000000
 0,         12,         12,        1,  1378560, 0x9c598000
 1,      25488,      25488,     1024,     8192, 0x00000000
 0,         13,         13,        1,  1378560, 0xbaf121ba
@@ -52,32 +52,32 @@
 1,      28552,      28552,     1024,     8192, 0x00000000
 1,      29576,      29576,     1024,     8192, 0x00000000
 0,         15,         15,        1,  1378560, 0x6579d31a
-1,      30600,      30600,     1024,     8192, 0x687330d2
-1,      31608,      31608,     1024,     8192, 0x9131462c
+1,      30600,      30600,     1024,     8192, 0x00000000
+1,      31608,      31608,     1024,     8192, 0x00000000
 0,         16,         16,        1,  1378560, 0xca1deba8
-1,      32688,      32688,     1024,     8192, 0x48c01c32
-1,      33712,      33712,     1024,     8192, 0x0ccd8d5f
+1,      32688,      32688,     1024,     8192, 0x00000000
+1,      33712,      33712,     1024,     8192, 0x00000000
 0,         17,         17,        1,  1378560, 0xd4eed467
-1,      34728,      34728,     1024,     8192, 0xd50cbe9f
-1,      35736,      35736,     1024,     8192, 0xbe069303
+1,      34728,      34728,     1024,     8192, 0x00000000
+1,      35736,      35736,     1024,     8192, 0x00000000
 0,         18,         18,        1,  1378560, 0xd6e1d5b7
-1,      36760,      36760,     1024,     8192, 0x85fccf5b
-1,      37784,      37784,     1024,     8192, 0x4180de71
+1,      36760,      36760,     1024,     8192, 0x00000000
+1,      37784,      37784,     1024,     8192, 0x00000000
 0,         19,         19,        1,  1378560, 0x0b574d39
-1,      38808,      38808,     1024,     8192, 0x0e9b6ac3
-1,      39816,      39816,     1024,     8192, 0x5c33f724
+1,      38808,      38808,     1024,     8192, 0x00000000
+1,      39816,      39816,     1024,     8192, 0x00000000
 0,         20,         20,        1,  1378560, 0x1bdd4d61
-1,      40840,      40840,     1024,     8192, 0x668aaaec
-1,      41864,      41864,     1024,     8192, 0xd137d412
+1,      40840,      40840,     1024,     8192, 0x00000000
+1,      41864,      41864,     1024,     8192, 0x00000000
 0,         21,         21,        1,  1378560, 0x3b28f549
-1,      42888,      42888,     1024,     8192, 0x08e1fbf6
-1,      43896,      43896,     1024,     8192, 0xbf3fb4f6
+1,      42888,      42888,     1024,     8192, 0x00000000
+1,      43896,      43896,     1024,     8192, 0x00000000
 0,         22,         22,        1,  1378560, 0x45b2f57b
-1,      44920,      44920,     1024,     8192, 0x69cd08a4
-1,      45944,      45944,     1024,     8192, 0xe0fe6297
+1,      44920,      44920,     1024,     8192, 0x00000000
+1,      45944,      45944,     1024,     8192, 0x00000000
 0,         23,         23,        1,  1378560, 0x8955570e
-1,      46968,      46968,     1024,     8192, 0x172867ad
-1,      47976,      47976,     1024,     8192, 0xcbcc1461
+1,      46968,      46968,     1024,     8192, 0x00000000
+1,      47976,      47976,     1024,     8192, 0x00000000
 0,         24,         24,        1,  1378560, 0x9c598000
 1,      49968,      49968,     1024,     8192, 0x00000000
 0,         25,         25,        1,  1378560, 0xbaf121ba
@@ -87,33 +87,33 @@
 1,      53032,      53032,     1024,     8192, 0x00000000
 0,         27,         27,        1,  1378560, 0x6579d31a
 1,      54056,      54056,     1024,     8192, 0x00000000
-1,      55080,      55080,     1024,     8192, 0x687330d2
+1,      55080,      55080,     1024,     8192, 0x00000000
 0,         28,         28,        1,  1378560, 0xca1deba8
-1,      56088,      56088,     1024,     8192, 0x9131462c
-1,      57168,      57168,     1024,     8192, 0x48c01c32
+1,      56088,      56088,     1024,     8192, 0x00000000
+1,      57168,      57168,     1024,     8192, 0x00000000
 0,         29,         29,        1,  1378560, 0xd4eed467
-1,      58192,      58192,     1024,     8192, 0x0ccd8d5f
-1,      59208,      59208,     1024,     8192, 0xd50cbe9f
+1,      58192,      58192,     1024,     8192, 0x00000000
+1,      59208,      59208,     1024,     8192, 0x00000000
 0,         30,         30,        1,  1378560, 0xd6e1d5b7
-1,      60216,      60216,     1024,     8192, 0xbe069303
-1,      61240,      61240,     1024,     8192, 0x85fccf5b
+1,      60216,      60216,     1024,     8192, 0x00000000
+1,      61240,      61240,     1024,     8192, 0x00000000
 0,         31,         31,        1,  1378560, 0x0b574d39
-1,      62264,      62264,     1024,     8192, 0x4180de71
-1,      63288,      63288,     1024,     8192, 0x0e9b6ac3
+1,      62264,      62264,     1024,     8192, 0x00000000
+1,      63288,      63288,     1024,     8192, 0x00000000
 0,         32,         32,        1,  1378560, 0x1bdd4d61
-1,      64296,      64296,     1024,     8192, 0x5c33f724
-1,      65320,      65320,     1024,     8192, 0x668aaaec
+1,      64296,      64296,     1024,     8192, 0x00000000
+1,      65320,      65320,     1024,     8192, 0x00000000
 0,         33,         33,        1,  1378560, 0x3b28f549
-1,      66344,      66344,     1024,     8192, 0xd137d412
-1,      67368,      67368,     1024,     8192, 0x08e1fbf6
+1,      66344,      66344,     1024,     8192, 0x00000000
+1,      67368,      67368,     1024,     8192, 0x00000000
 0,         34,         34,        1,  1378560, 0x45b2f57b
-1,      68376,      68376,     1024,     8192, 0xbf3fb4f6
-1,      69400,      69400,     1024,     8192, 0x69cd08a4
+1,      68376,      68376,     1024,     8192, 0x00000000
+1,      69400,      69400,     1024,     8192, 0x00000000
 0,         35,         35,        1,  1378560, 0x8955570e
-1,      70424,      70424,     1024,     8192, 0xe0fe6297
-1,      71448,      71448,     1024,     8192, 0x172867ad
+1,      70424,      70424,     1024,     8192, 0x00000000
+1,      71448,      71448,     1024,     8192, 0x00000000
 0,         36,         36,        1,  1378560, 0x9c598000
-1,      72456,      72456,     1024,     8192, 0xcbcc1461
+1,      72456,      72456,     1024,     8192, 0x00000000
 0,         37,         37,        1,  1378560, 0xbaf121ba
 1,      74448,      74448,     1024,     8192, 0x00000000
 1,      75472,      75472,     1024,     8192, 0x00000000
@@ -122,30 +122,30 @@
 1,      77512,      77512,     1024,     8192, 0x00000000
 0,         39,         39,        1,  1378560, 0x6579d31a
 1,      78536,      78536,     1024,     8192, 0x00000000
-1,      79560,      79560,     1024,     8192, 0x687330d2
+1,      79560,      79560,     1024,     8192, 0x00000000
 0,         40,         40,        1,  1378560, 0xca1deba8
-1,      80568,      80568,     1024,     8192, 0x9131462c
-1,      81648,      81648,     1024,     8192, 0x48c01c32
+1,      80568,      80568,     1024,     8192, 0x00000000
+1,      81648,      81648,     1024,     8192, 0x00000000
 0,         41,         41,        1,  1378560, 0xd4eed467
-1,      82672,      82672,     1024,     8192, 0x0ccd8d5f
-1,      83688,      83688,     1024,     8192, 0xd50cbe9f
+1,      82672,      82672,     1024,     8192, 0x00000000
+1,      83688,      83688,     1024,     8192, 0x00000000
 0,         42,         42,        1,  1378560, 0xd6e1d5b7
-1,      84696,      84696,     1024,     8192, 0xbe069303
-1,      85720,      85720,     1024,     8192, 0x85fccf5b
+1,      84696,      84696,     1024,     8192, 0x00000000
+1,      85720,      85720,     1024,     8192, 0x00000000
 0,         43,         43,        1,  1378560, 0x0b574d39
-1,      86744,      86744,     1024,     8192, 0x4180de71
-1,      87768,      87768,     1024,     8192, 0x0e9b6ac3
+1,      86744,      86744,     1024,     8192, 0x00000000
+1,      87768,      87768,     1024,     8192, 0x00000000
 0,         44,         44,        1,  1378560, 0x1bdd4d61
-1,      88776,      88776,     1024,     8192, 0x5c33f724
-1,      89800,      89800,     1024,     8192, 0x668aaaec
+1,      88776,      88776,     1024,     8192, 0x00000000
+1,      89800,      89800,     1024,     8192, 0x00000000
 0,         45,         45,        1,  1378560, 0x3b28f549
-1,      90824,      90824,     1024,     8192, 0xd137d412
-1,      91848,      91848,     1024,     8192, 0x08e1fbf6
+1,      90824,      90824,     1024,     8192, 0x00000000
+1,      91848,      91848,     1024,     8192, 0x00000000
 0,         46,         46,        1,  1378560, 0x45b2f57b
-1,      92856,      92856,     1024,     8192, 0xbf3fb4f6
-1,      93880,      93880,     1024,     8192, 0x69cd08a4
+1,      92856,      92856,     1024,     8192, 0x00000000
+1,      93880,      93880,     1024,     8192, 0x00000000
 0,         47,         47,        1,  1378560, 0x8955570e
-1,      94904,      94904,     1024,     8192, 0xe0fe6297
-1,      95928,      95928,     1024,     8192, 0x172867ad
-1,      96936,      96936,     1024,     8192, 0xcbcc1461
+1,      94904,      94904,     1024,     8192, 0x00000000
+1,      95928,      95928,     1024,     8192, 0x00000000
+1,      96936,      96936,     1024,     8192, 0x00000000
 0,         49,         49,        1,  1378560, 0x9c598000