diff --git a/tests/fate/flvenc.mak b/tests/fate/flvenc.mak
index 5032fface3..f34c595f88 100644
--- a/tests/fate/flvenc.mak
+++ b/tests/fate/flvenc.mak
@@ -1,5 +1,10 @@
 FATE_FLVENC_FFMPEG_FFPROBE-$(call TRANSCODE, FLV, FLV, RAWVIDEO_DECODER SCALE_FILTER TESTSRC_FILTER LAVFI_INDEV) += fate-flv-add_keyframe_index
 fate-flv-add_keyframe_index: CMD = transcode "lavfi -graph testsrc=r=7:n=2:d=20" "foo" flv "-vf scale -c:v flv1 -dct int -g 7 -flvflags add_keyframe_index" "-c copy -t 0.1" "-show_entries format_tags"
 
+FATE_ENHANCED_FLVENC_FFMPEG-$(call REMUX, FLV MOV, FLV_DEMUXER HEVC_PARSER) += fate-enhanced-flv-hevc
+fate-enhanced-flv-hevc: CMD = stream_remux mov $(TARGET_SAMPLES)/hevc/dv84.mov\
+		flv "-c copy" "-c copy"
+
 FATE_FFMPEG_FFPROBE += $(FATE_FLVENC_FFMPEG_FFPROBE-yes)
-fate-flvenc: $(FATE_FLVENC_FFMPEG_FFPROBE-yes)
+FATE_SAMPLES_FFMPEG += $(FATE_ENHANCED_FLVENC_FFMPEG-yes)
+fate-flvenc: $(FATE_FLVENC_FFMPEG_FFPROBE-yes) $(FATE_ENHANCED_FLVENC_FFMPEG-yes)
diff --git a/tests/ref/fate/enhanced-flv-hevc b/tests/ref/fate/enhanced-flv-hevc
new file mode 100644
index 0000000000..774c5e6df4
--- /dev/null
+++ b/tests/ref/fate/enhanced-flv-hevc
@@ -0,0 +1,256 @@
+#extradata 0:      551, 0xa18acf66
+#extradata 1:        2, 0x00340022
+#tb 0: 1/1000
+#media_type 0: video
+#codec_id 0: hevc
+#dimensions 0: 1920x1080
+#sar 0: 0/1
+#tb 1: 1/1000
+#media_type 1: audio
+#codec_id 1: aac
+#sample_rate 1: 44100
+#channel_layout_name 1: stereo
+0,          0,          0,       33,    63375, 0xc76606ab
+0,         33,         33,       33,    46706, 0x0e08a7e5, F=0x0
+0,         66,         66,       33,    29766, 0x753c031a, F=0x0
+1,         68,         68,       23,        6, 0x031e0108
+1,         91,         91,       23,      251, 0x6b4a7cbd
+0,        100,        100,       33,    19409, 0x4b948b6c, F=0x0
+1,        114,        114,       23,      389, 0x6673c205
+0,        133,        133,       33,    21086, 0x1b9412ce, F=0x0
+1,        138,        138,       23,      356, 0x8c71a316
+1,        161,        161,       23,      339, 0x3018a45a
+0,        166,        166,       33,    62043, 0xc2356b56, F=0x0
+1,        184,        184,       23,      405, 0xc89ebe05
+0,        200,        200,       33,    36175, 0x0a7df38c, F=0x0
+1,        207,        207,       23,      449, 0x42eadf96
+1,        231,        231,       23,      416, 0x28a7c9b9
+0,        233,        233,       33,    16028, 0xa57fcbe9, F=0x0
+1,        254,        254,       23,      426, 0x9a74d4ec
+0,        266,        266,       33,    15428, 0x9a91f357, F=0x0
+1,        277,        277,       23,      419, 0xbe3dc54b
+0,        300,        300,       33,    66072, 0xa542b6d7, F=0x0
+1,        300,        300,       23,      424, 0x5102d50e
+1,        323,        323,       23,      402, 0xb11cc14c
+0,        333,        333,       33,    34985, 0xbfd8ff45, F=0x0
+1,        347,        347,       23,      401, 0x3820b8f9
+0,        366,        366,       33,    16036, 0xfc39c6ea, F=0x0
+1,        370,        370,       23,      400, 0xe5c4c168
+1,        393,        393,       23,      435, 0x6dbecc33
+0,        400,        400,       33,    19893, 0x7e746f4e, F=0x0
+1,        416,        416,       23,      441, 0x0ad3d199
+0,        433,        433,       33,    77576, 0xeba2e5c8, F=0x0
+1,        440,        440,       23,      479, 0x44dce967
+1,        463,        463,       23,      439, 0x7d85e4c9
+0,        466,        466,       33,    35400, 0xbe179462, F=0x0
+1,        486,        486,       23,      461, 0xca18e36b
+0,        500,        500,       33,    15962, 0x7703dcd8, F=0x0
+1,        509,        509,       23,      498, 0xf73befd7
+1,        532,        532,       23,      469, 0x0119e958
+0,        533,        533,       33,    16136, 0x78a74880, F=0x0
+1,        556,        556,       23,      472, 0x4980e108
+0,        566,        566,       33,    74990, 0xb6fc1da7, F=0x0
+1,        579,        579,       23,      488, 0x42baeb77
+0,        600,        600,       33,    36594, 0xc3c61c3e, F=0x0
+1,        602,        602,       23,      458, 0x2198dde8
+1,        625,        625,       23,      430, 0x0858cc8f
+0,        633,        633,       33,    16524, 0xb297a886, F=0x0
+1,        648,        648,       23,      464, 0x9590e068
+0,        666,        666,       33,    17033, 0x31b3dd63, F=0x0
+1,        672,        672,       23,      415, 0xf926cf5f
+1,        695,        695,       23,      429, 0xf4a4d6c3
+0,        700,        700,       33,    66745, 0x5edee4b1, F=0x0
+1,        718,        718,       23,      420, 0xb64ac826
+0,        733,        733,       33,    37648, 0x540b100f, F=0x0
+1,        741,        741,       23,      442, 0xae2fd0ef
+1,        765,        765,       23,      426, 0xf1b7ccff
+0,        766,        766,       33,    16363, 0x569798e5, F=0x0
+1,        788,        788,       23,      435, 0xd3a1cb35
+0,        800,        800,       33,    17112, 0x9f04002b, F=0x0
+1,        811,        811,       23,      424, 0xc204c05d
+0,        833,        833,       33,    69462, 0x6ed4d0a2, F=0x0
+1,        834,        834,       23,      448, 0x3a3adc76
+1,        857,        857,       23,      451, 0x6a1bd675
+0,        866,        866,       33,    34772, 0x2baa0683, F=0x0
+1,        881,        881,       23,      440, 0x6219d30d
+0,        900,        900,       33,    14301, 0x8d69c797, F=0x0
+1,        904,        904,       23,      438, 0xb55dd535
+1,        927,        927,       23,      412, 0xd591ccfd
+0,        933,        933,       33,    16355, 0x1ebb9962, F=0x0
+1,        950,        950,       23,      419, 0x1069d097
+0,        966,        966,       33,   107788, 0xcf28b065
+1,        974,        974,       23,      407, 0x1a3ec967
+1,        997,        997,       23,      400, 0x4ca1c7e9
+0,       1000,       1000,       33,    35514, 0xa824dec0, F=0x0
+1,       1020,       1020,       23,      465, 0x8dbbdfa5
+0,       1033,       1033,       33,    15937, 0x8c06a068, F=0x0
+1,       1043,       1043,       23,      444, 0xed1cd498
+0,       1066,       1066,       33,    15936, 0x1a01f3e9, F=0x0
+1,       1066,       1066,       23,      414, 0xada6c395
+1,       1090,       1090,       23,      419, 0x7d64d269
+0,       1100,       1100,       33,    79014, 0xef4c241e, F=0x0
+1,       1113,       1113,       23,      415, 0xf2e5c75d
+0,       1133,       1133,       33,    37293, 0xb32c9665, F=0x0
+1,       1136,       1136,       23,      431, 0xeae2d257
+1,       1159,       1159,       23,      437, 0x10c1cfa6
+0,       1168,       1168,       33,    12826, 0xddc8ba8d, F=0x0
+1,       1183,       1183,       23,      428, 0x9b18ce7e
+0,       1201,       1201,       33,    13376, 0x76fbc02f, F=0x0
+1,       1206,       1206,       23,      426, 0xec1bce70
+1,       1229,       1229,       23,      433, 0xad18d26f
+0,       1235,       1235,       33,    68959, 0x5fdeaeac, F=0x0
+1,       1252,       1252,       23,      419, 0x99beccaf
+0,       1268,       1268,       33,    35503, 0x15dbf810, F=0x0
+1,       1275,       1275,       23,      422, 0x38add249
+1,       1299,       1299,       23,      335, 0x243499db
+0,       1301,       1301,       33,    12298, 0xbc12d96e, F=0x0
+1,       1322,       1322,       23,      427, 0x614fccd2
+0,       1335,       1335,       33,    16357, 0x3bb3e5c9, F=0x0
+1,       1345,       1345,       23,      434, 0xd97acebe
+0,       1368,       1368,       33,    69872, 0x643e0e8a, F=0x0
+1,       1368,       1368,       23,      427, 0x0a24cf66
+1,       1392,       1392,       23,      406, 0x868bc306
+0,       1401,       1401,       33,    35059, 0xab5881c4, F=0x0
+1,       1415,       1415,       23,      410, 0x32c4cd52
+0,       1435,       1435,       33,    17718, 0xe78b5150, F=0x0
+1,       1438,       1438,       23,      416, 0xbd3dcaa5
+1,       1461,       1461,       23,      420, 0x42c5ccf6
+0,       1468,       1468,       33,    17264, 0xd5297233, F=0x0
+1,       1484,       1484,       23,      437, 0xe302cd64
+0,       1501,       1501,       33,    68258, 0xea19d5bb, F=0x0
+1,       1508,       1508,       23,      444, 0xdc1ad47f
+1,       1531,       1531,       23,      472, 0xc314e301
+0,       1535,       1535,       33,    34019, 0x1c25277c, F=0x0
+1,       1554,       1554,       23,      466, 0xdb51e992
+0,       1568,       1568,       33,    16085, 0xfc5f1909, F=0x0
+1,       1577,       1577,       23,      425, 0x35b6c4be
+0,       1601,       1601,       33,    17133, 0xccd80c32, F=0x0
+1,       1601,       1601,       23,      429, 0xd479cc89
+1,       1624,       1624,       23,      424, 0x0994cbfa
+0,       1635,       1635,       33,    65478, 0x92adbcf5, F=0x0
+1,       1647,       1647,       23,      424, 0x1145cad4
+0,       1668,       1668,       33,    35702, 0x85da366e, F=0x0
+1,       1670,       1670,       23,      417, 0x0cb5c9d6
+1,       1693,       1693,       23,      425, 0xd316c722
+0,       1701,       1701,       33,    17729, 0x7c6037dd, F=0x0
+1,       1717,       1717,       23,      412, 0x97d8c424
+0,       1735,       1735,       33,    16400, 0x07509624, F=0x0
+1,       1740,       1740,       23,      422, 0x444ad135
+1,       1763,       1763,       23,      436, 0x0575c48b
+0,       1768,       1768,       33,    65450, 0xc93a8591, F=0x0
+1,       1786,       1786,       23,      418, 0xdd73c42f
+0,       1801,       1801,       33,    30572, 0xe4892d21, F=0x0
+1,       1809,       1809,       23,      412, 0x64d0c0cd
+1,       1833,       1833,       23,      417, 0xf7e3cc8d
+0,       1835,       1835,       33,    16836, 0x34466a29, F=0x0
+1,       1856,       1856,       23,      414, 0xef17ca47
+0,       1868,       1868,       33,    16615, 0x06f42746, F=0x0
+1,       1879,       1879,       23,      420, 0x86f5d28f
+0,       1901,       1901,       33,    61621, 0x455e8141, F=0x0
+1,       1902,       1902,       23,      415, 0x73dec27c
+1,       1926,       1926,       23,      451, 0x62abdbfb
+0,       1935,       1935,       33,    35393, 0x91e3f353, F=0x0
+1,       1949,       1949,       23,      511, 0xbb42f40b
+0,       1968,       1968,       33,    16421, 0xb5a4a3fd, F=0x0
+1,       1972,       1972,       23,      470, 0xe422df11
+1,       1995,       1995,       23,      459, 0x7c24e067
+0,       2001,       2001,       33,    15874, 0x8a12e636, F=0x0
+1,       2018,       2018,       23,      464, 0xb1a5ebf6
+0,       2035,       2035,       33,   108249, 0x74b9d9a5
+1,       2042,       2042,       23,      435, 0x7acbd073
+1,       2065,       2065,       23,      475, 0x9498e6ff
+0,       2068,       2068,       33,    32427, 0x1b4e36e9, F=0x0
+1,       2088,       2088,       23,      473, 0xf42ddcb4
+0,       2101,       2101,       33,    15263, 0xc96d6375, F=0x0
+1,       2111,       2111,       23,      439, 0x898ad0ed
+0,       2135,       2135,       33,    15124, 0x24bf4865, F=0x0
+1,       2135,       2135,       23,      483, 0x94f5e826
+1,       2158,       2158,       23,      474, 0x80b8f7ad
+0,       2168,       2168,       33,    66156, 0x9536eb3a, F=0x0
+1,       2181,       2181,       23,      495, 0xd027e373
+0,       2201,       2201,       33,    33590, 0x12693d54, F=0x0
+1,       2204,       2204,       23,      479, 0x4841ea3d
+1,       2227,       2227,       23,      446, 0x0b64d3e2
+0,       2235,       2235,       33,    15633, 0xa1f67306, F=0x0
+1,       2251,       2251,       23,      464, 0xc939de26
+0,       2268,       2268,       33,    16075, 0x1ee82b38, F=0x0
+1,       2274,       2274,       23,      457, 0xc069e099
+1,       2297,       2297,       23,      451, 0x2f22d7a1
+0,       2301,       2301,       33,    63442, 0xb508621f, F=0x0
+1,       2320,       2320,       23,      475, 0x4de7e675
+0,       2335,       2335,       33,    35773, 0xa79485e3, F=0x0
+1,       2344,       2344,       23,      464, 0x430de113
+1,       2367,       2367,       23,      428, 0x6546c66d
+0,       2368,       2368,       33,    16970, 0x6fcf7d2c, F=0x0
+1,       2390,       2390,       23,      455, 0xb5e5db4f
+0,       2401,       2401,       33,    17773, 0x3a10880d, F=0x0
+1,       2413,       2413,       23,      493, 0xae57eafd
+0,       2435,       2435,       33,    66942, 0x91535a55, F=0x0
+1,       2436,       2436,       23,      448, 0xa170db5e
+1,       2460,       2460,       23,      419, 0x0bfec67f
+0,       2468,       2468,       33,    36289, 0xd1337338, F=0x0
+1,       2483,       2483,       23,      406, 0x2e33d13b
+0,       2501,       2501,       33,    16878, 0x0c83a101, F=0x0
+1,       2506,       2506,       23,      395, 0x0ef7c208
+1,       2529,       2529,       23,      397, 0x736fc48d
+0,       2535,       2535,       33,    17452, 0x8c3cb218, F=0x0
+1,       2553,       2553,       23,      463, 0x6397def2
+0,       2568,       2568,       33,    64256, 0x2243ae19, F=0x0
+1,       2576,       2576,       23,      414, 0x4c5fc473
+1,       2599,       2599,       23,      426, 0x7028d53d
+0,       2601,       2601,       33,    33995, 0x3634ef46, F=0x0
+1,       2622,       2622,       23,      382, 0x7344b178
+0,       2635,       2635,       33,    17505, 0xb70bdaef, F=0x0
+1,       2645,       2645,       23,      400, 0x17ecb9e3
+0,       2668,       2668,       33,    17420, 0x0a39d08d, F=0x0
+1,       2669,       2669,       23,      384, 0x40cfba37
+1,       2692,       2692,       23,      420, 0xb01cce29
+0,       2701,       2701,       33,    64814, 0x52eba8da, F=0x0
+1,       2715,       2715,       23,      443, 0x2b15dd89
+0,       2735,       2735,       33,    35168, 0x3bae1145, F=0x0
+1,       2738,       2738,       23,      456, 0xf875e323
+1,       2762,       2762,       23,      448, 0x190fd804
+0,       2768,       2768,       33,    18363, 0x5aac8d0b, F=0x0
+1,       2785,       2785,       23,      408, 0x54f8c9ae
+0,       2801,       2801,       33,    18577, 0x3ef410e2, F=0x0
+1,       2808,       2808,       23,      404, 0x6812c0cc
+1,       2831,       2831,       23,      457, 0x9618e228
+0,       2835,       2835,       33,    65960, 0xd928efea, F=0x0
+1,       2854,       2854,       23,      470, 0x3371e47e
+0,       2868,       2868,       33,    35750, 0x1e6b3528, F=0x0
+1,       2878,       2878,       23,      476, 0x3e0dea61
+0,       2901,       2901,       33,    18109, 0x04a60f42, F=0x0
+1,       2901,       2901,       23,      438, 0x7e1aca04
+1,       2924,       2924,       23,      468, 0xe22de588
+0,       2935,       2935,       33,    18965, 0xce88b8c2, F=0x0
+1,       2947,       2947,       23,      448, 0xf820d2df
+0,       2968,       2968,       33,    64413, 0x0e2a7b8d, F=0x0
+1,       2970,       2970,       23,      446, 0x4346da55
+1,       2994,       2994,       23,      413, 0x8091c5e5
+0,       3001,       3001,       33,    36536, 0x1b69fcc7, F=0x0
+1,       3017,       3017,       23,      447, 0x799cdff9
+0,       3035,       3035,       33,    16823, 0xc226cdd8, F=0x0
+1,       3040,       3040,       23,      485, 0x61f0e3ee
+1,       3063,       3063,       23,      446, 0x09aad595
+0,       3068,       3068,       33,    18254, 0xe28d2b32, F=0x0
+1,       3087,       3087,       23,      503, 0x5ff6f1bd
+0,       3101,       3101,       33,   108398, 0x04e8955a
+1,       3110,       3110,       23,      481, 0x680bf2ff
+1,       3133,       3133,       23,      481, 0x77e1e3eb
+0,       3135,       3135,       33,    39214, 0xc82d25cc, F=0x0
+1,       3156,       3156,       23,      500, 0xf446f43a
+0,       3168,       3168,       33,    17093, 0x81e01006, F=0x0
+1,       3179,       3179,       23,      503, 0x5a21f932
+0,       3201,       3201,       33,    16220, 0xb8b86777, F=0x0
+1,       3203,       3203,       23,      443, 0x503bd45b
+1,       3226,       3226,       23,      443, 0xb652e056
+0,       3235,       3235,       33,    60533, 0xc63d4419, F=0x0
+1,       3249,       3249,       23,      441, 0xb0bbdc3e
+0,       3268,       3268,       33,    27638, 0xcd9cb6d0, F=0x0
+1,       3272,       3272,       23,      410, 0xa2aeb940
+1,       3296,       3296,       23,      430, 0x9b32d228
+0,       3301,       3301,       33,    16528, 0x5e9dc6fd, F=0x0
+1,       3319,       3319,       23,      406, 0xd3ccc550
+1,       3342,       3342,       23,      397, 0xcf2bc6d6
+1,       3365,       3365,       23,      411, 0xecf7bf70
+1,       3388,       3388,       23,      403, 0x4a35c58a